#!/usr/local/bin/perl

our ($find, @termname, @funcname, @wordname);

$find = sub {
  my $filename = shift;
  chomp(my $pwd = `pwd`);

  #First, try this directory
  return $filename if -e $filename;

  #Next, see if we're in a subdir of data
  my $pwd2 = $pwd;
  if ($pwd2 =~ s# data(/.*)$ #data#x) {
    my $fullname = $pwd2 . "/" . $filename;
    return $fullname if -e $fullname;
  }

  #Next, try each parent directory for file and data/file.
  do {
    my $fullname = $pwd . "/data/" . $filename;
    return $fullname if -e $fullname;
    $fullname = $pwd . "/" . $filename;
    return $fullname if -e $fullname;
  } while ($pwd =~ s# /\w*$ ##x);

  die "Sorry, can't find $filename in any of the obvious places.\n";
};

open TERM, &{$find}("terms.txt");
@termname = ();
while (<TERM>) {
  chomp;
  my $t = (split)[0];
  push @termname, $t;
}
close TERM;

open FUNC, &{$find}("funcs.txt");
@funcname = ('NONE');
while (<FUNC>) {
  chomp;
  my $f = (split)[0];
  push @funcname, $f;
}
close FUNC;

open WORD, &{$find}("pSgT.txt");
@wordname = ();
<WORD>; <WORD>; <WORD>;  # Three lines of chaff
while (<WORD>) {
  chomp;
  my $w = (split)[0];
  push @wordname, $w;
}
close WORD;

1;
