#include "ECArgs.h"
#include <cstdio>
#include <set>
#include "utils.h"
#include <algorithm>

using namespace std;

ECArgs::
ECArgs(int argc, char *argv[], const string& argoptstr)
{
  set<char> argopts;
  for (int i = 0; i < argoptstr.length(); ++i)
    argopts.insert(argoptstr[i]);

  nargs_ = 0;
  for(int i = 1 ; i < argc ; i++)
    {
      string arg(argv[i]);
      if(arg[0] != '-')
	{
	  argList[nargs_] = arg;
	  nargs_++;
	}
      else
	{
	  nopts_++;
	  int l = arg.length();
	  assert(l > 1);
	  char optch = arg[1];
	  optList.push_back(string(1, optch));
	  if (l == 2)
	  {
	    if (argopts.count(optch))
	    {
	      ++i;
	      if (i >= argc) error ("Option not followed by argument!");
	      arg = argv[i];
	      optList.push_back(arg);
	    }
	    else
	      optList.push_back("");
	  }
	  else
	    optList.push_back(string(arg,2,l-2));
	}
    }
}

bool
ECArgs::
isset(char c)
{
  string sig = "";
  sig += c;
  list<string>::iterator
    oIter = find(optList.begin(), optList.end(), sig);
  bool found = (oIter != optList.end());
  return found;
}


string
ECArgs::
value(char c)
{
  string sig;
  sig += c;

  list<string>::iterator oIter = find(optList.begin(), optList.end(), sig);
  bool found = (oIter != optList.end());
  if(!found)
    {
      cerr << "Looking for value of on-line argument " << sig << endl;
      error("could not find value");
    }
  ++oIter;
  return *oIter;
}


