
#ifndef HIST_H
#define HIST_H

#include <string>
#include <list>

class Hist
{ 
  public:
    virtual int getHeadPosition() const = 0;
    virtual int getPosition() const = 0;
    virtual int getLabel() const = 0;
    virtual int getStart() const = 0;
    virtual int getFinish() const = 0;
    virtual int getHeadPOS() const = 0;
    virtual int getHead() const = 0;
    virtual bool isHeadKnown() const = 0;
    virtual std::string getHeadString() const = 0;
    virtual int getFunctionTag(int i) const = 0;

    virtual const Hist* getParent() const = 0;
    virtual const std::list<Hist*>& getChildren() const = 0;
    virtual int getNumChildren() const = 0;
    virtual int getChildLabel (int i) const = 0;

    virtual bool isConjunctivePhrase() const = 0;
};

#endif
