#include "InputParseTree.h"


void InputParseTree::linePrint(ostream& os) const
{
  if (isLeaf())
    os << getLabel() << endl;
  else
  {
    os << '(' << endl << getLabel() << endl;
    //cerr << label << "!!" << tags.size() << endl;
    assert (tags.size() < 5);
    for (vector<string>::const_iterator it = tags.begin();
	 it != tags.end();
	 ++it)
    {
      assert (it);
      os << '-' << *it << endl;
    }
    int hnum = FuncInfo::getHyphNum(tree->ntInfo());
    //if (hnum != -1) os << '-' << hnum << endl;
    int eqnum = FuncInfo::getEqNum(tree->ntInfo());
    //if (eqnum != -1) os << '=' << eqnum << endl;
    for (vector<GenericTree*>::const_iterator it = children.begin();
	 it != children.end();
	 ++it)
    {
      ((InputParseTree *)*it)->linePrint(os);
    }
    os << ')' << endl;
  }
}
