
#ifndef MECHART_H
#define MECHART_H

#include <string>
#include "AnswerTree.h"
#include "Bchart.h"
#include "FullHist.h"
#include "FeatureTree.h"
#include "Feature.h"
#include "FuncInfo.h"
#include "Item.h"

using namespace std;

class MeChart : public Bchart
{
 public:
  MeChart(SentRep & sentence)
     : Bchart( sentence ) {}
  static void  init(string path);
  AnswerTree*      findMapParse();
  AnswerTreePair bestParse(Item* itm, FullHist* h);  // restore &
  AnswerTreePair bestFuncGivenHead(int posInt, const Wrd& wd, Item* itm,
				     FullHist* h, ItmGHeadInfo& ighInfo);
  AnswerTreePair bestParseGivenHead(int posInt, const Wrd& wd, Item* itm,
				     FullHist* h, ItmGHeadInfo& ighInfo);
  AnswerTreePair& bestParseGivenHead2(int posInt, const Wrd& wd, Item* itm,
				     FullHist* h, ItmGHeadInfo& ighInfo);
  void  fillInHeads();
  bool  headsFromEdges(Item* itm);
  Item * headItem(Edge* edge);
  void  getHt(FullHist* h, int* subfVals);
  float getpHst(const string& hd, int t);
  AnswerTreePair& recordedBP(Item* itm, FullHist* h);
  AnswerTreePair& recordedBPGH(Item* itm, AnswerTreeMap& atm, FullHist* h);
  float meHeadProb(int wInt, FullHist* h);
  float meProb(int val, FullHist* h, int which);
  float meRuleProb(Edge* e, FullHist* h);
  void  getRelFeats(int c, int c2, int which, Feat* relFeat[],
		    FeatureTree* fts[], FullHist* h, int facPos);
  bool  okDecendent(Item* chld, FullHist* ph);
  vector<FunctionTagPair> tagsForNode(int whichTag, Item* itm, FullHist* h, bool knownhead);

  int     ccbucket(float val, float* buckets , int sz);
  static void    initCCArrays(string path);
  static void    initccarray(ifstream& is, float lenArray[6][8]);
  float   ccLenProb(Edge* edge, int effend);
};

#endif
