
#ifndef PARSESTATS_H
#define PARSESTATS_H

#include <iostream>
#include <cstring>


class ParseStats
{
 public:
  ParseStats() : totalMap( 0 ), obviousMap( 0 ),
                 correctMap( 0 ), totalPrecision( 0 ),
                 obviousPrecision( 0 ), correctPrecision( 0 ),
                 totalExact( 0 ), ignoredExact( 0 ),
                 exactMap( 0 ), exactPrecision( 0 ),
                 otherWrong( 0 ), complementPrecision( 0 )
		 {
		   memset (funcTagPrecisionA, 0, 4*sizeof(*funcTagPrecisionA));
		   memset (funcTagPrecisionB, 0, 4*sizeof(*funcTagPrecisionA));
		   memset (funcTagPrecisionC, 0, 4*sizeof(*funcTagPrecisionA));
		   memset (funcTagPrecisionD, 0, 4*sizeof(*funcTagPrecisionA));
		   memset (funcTagPrecisionE, 0, 4*sizeof(*funcTagPrecisionA));
		 }
  ParseStats( std::istream& is ){ readInput( is ); }
  friend std::istream& operator >>( std::istream& is, ParseStats& ps );
  friend std::ostream& operator <<( std::ostream& os, const ParseStats& ps );
  ParseStats &    operator+= (const ParseStats & ps);	// merge operator.
  int numFuncErrors(int func) const
    { return funcTagPrecisionB[func]
             + funcTagPrecisionD[func] 
	     + funcTagPrecisionE[func]; 
    }
  int totalMap;
  int obviousMap;
  int correctMap;
  int totalPrecision;
  int obviousPrecision;
  int correctPrecision;
  int totalExact;
  int ignoredExact;
  int exactMap;
  int exactPrecision;
  int otherWrong;
  int complementPrecision;
  int funcTagPrecisionA[4];
  int funcTagPrecisionB[4];
  int funcTagPrecisionC[4];
  int funcTagPrecisionD[4];
  int funcTagPrecisionE[4];
 private:
  void readInput( std::istream& is );
};

#endif /* ! PARSESTATS_H */
