
#ifndef TREEHIST_H
#define TREEHIST_H

#include "FuncInfo.h"
#include "ccInd.h"
#include "Hist.h"

class InputTree;

class TreeHist: public Hist
{
 public:
  InputTree* tree;
  TreeHist*  parent;
  list<Hist*> children;
  /// Bookmark; which child of me am I currently working on
  int        pos;
  /// Marks which child of me contains my head
  int        hpos; 

 public:
  void setParent(TreeHist* par) { parent = par; }
  void setPosition(int i) { pos = i; }
  void setHeadPosition(int i) { hpos = i; }

  friend class InputTree;

 public:
  //TreeHist(InputTree* tr, int ps) : tree(tr), pos(ps) {}
  TreeHist(InputTree* tr, list<Hist*> kids) 
    : tree(tr), children(kids), pos(-1), parent(NULL), hpos(-1)
    { }

  int getHeadPosition() const { return hpos; }
  int getPosition() const { return pos; }
  int getLabel() const;
  int getStart() const;
  int getFinish() const;
  int getHeadPOS() const;
  bool isHeadKnown() const { return true; }
  int getHead() const;
  string getHeadString() const;
  int getFunctionTag(int i) const;

  const Hist* getParent() const { return parent; }
  const list<Hist*>& getChildren() const { return children; }
  int getNumChildren() const;
  int getChildLabel (int i) const;

  bool isConjunctivePhrase() const { return ccIndFromTree(tree); }
};

#endif /* ! TREEHIST_H */
