
#ifndef WRD_H 
#define WRD_H

#include <string>
#include <iostream>

using namespace std;

class Wrd;
class Wrd
{
public:
  friend class SentRep;
  Wrd() : lexeme_(""), loc_(-1) {}
  Wrd(const Wrd& wrd) : lexeme_(wrd.lexeme()),loc_(wrd.loc()),wInt_(wrd.toInt()) {}
  Wrd(string lx, int ps) : lexeme_(lx), loc_(ps) {}
  const string&  lexeme() const { return lexeme_; }
  friend int operator<(const Wrd& w1, const Wrd& w2)
    { return w1.lexeme_ < w2.lexeme_; }
  friend int operator==(const Wrd& w1, const Wrd& w2)
    { return w1.lexeme_ == w2.lexeme_; }
  friend istream& operator>>(istream& is, Wrd& w)
    {
      is >> w.lexeme_;
      return is;
    }
  friend ostream& operator<<(ostream& os, const Wrd& w)
    {
      os << w.lexeme_;
      return os;
    }
  void operator=(const Wrd& wr)
    {
      lexeme_ = wr.lexeme();
      loc_ = wr.loc();
    }
  int loc() const { return loc_; }
  int toInt() const { return wInt_; }
  int& toInt() { return wInt_; }
private:
  int loc_;
  int wInt_;
  string lexeme_;
};

#endif
