
#include "ccInd.h"
#include <string>
#include "InputTree.h"
#include "Term.h"

using namespace std;

/** Returns 1 iff the argument is a conjunctive phrase of some sort */
int
ccIndFromTree(InputTree* tree)
{
  InputTreesIter  subTreeIter = tree->subTrees().begin();
  string trm = tree->term();
  bool sawComma = false;
  int numTrm = 0;
  int pos = 0;
  for( ; subTreeIter != tree->subTrees().end() ; subTreeIter++ )
    {
      InputTree* subTree = *subTreeIter;
      if(pos != 0 && (subTree->term() == "CC" || subTree->term() == "CONJP"))
	return 1;
      if(subTree->term() == trm) numTrm++;
      if(pos != 0 && (subTree->term() == "," || subTree->term() == ":"))
	sawComma = true;
      pos++;
    }
  /* counts NP -> NP, NP as a conjuncion ??? */
  if(sawComma && numTrm >= 2) return 1;
  return 0;
}

/** Modifies a label based on whether it is built from a conjunction.
  * @param lspec the label to maybe be modified
  * @param ccInd whether the label is built from a conjunction
  * @return iff the label is build from conjunction and lspec is one of
  	NP, VP, or S, return a new tag CONJNP, CONJVP, or CONJS (actually
	G1, G2, and G3). */
int
ltocc(int lspec, int ccInd)
{
  static int npcc = -1;
  static int vpcc = -1;
  static int scc = -1;
  if(npcc < 0)
    {
      npcc = Term::get("CONJNP")->toInt();
      vpcc = Term::get("CONJVP")->toInt();
      scc = Term::get("CONJS")->toInt();
    }
  if(!ccInd) return lspec;
  string nm = Term::fromInt(lspec)->name();
  if(nm == "NP") return npcc;
  else if(nm == "VP") return vpcc;
  else if(nm == "S") return scc;
  else return lspec;
}

